﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Player : MonoBehaviour {
    public float speed=5;
    private Rigidbody rigid;//リジッドボデー
    private float m_Time;//時間
    bool m_Jump = false;
    public float m_High=50.0f;
    public float gravity = 0.5f;
    public float m_RotatteSpeed = 0.5f;
    bool JumpFlag = true;
    private Vector3 m_StarPos;
    private Quaternion m_StartRotation;//始めのローテーション
    private Transform trans;
    float a=0.0f;
    bool ScorePuls = false;//スコアを加算かどうか

    int score = 0;//加算するスコア量
    // Use this for initialization
    void Start()
    {
        rigid = GetComponent<Rigidbody>();
        trans = GetComponent<Transform>();
        m_StarPos = trans.position;
        m_StartRotation = GetComponent<Transform>().transform.rotation ;
        
        SoundPlayer.PlayBGM(SoundPlayer.BGM.MAIN);
    }
	
	// Update is called once per frame
	void Update () {
        m_Time = Time.deltaTime;//前フレームからの時間
        //左右のキーで移動する
        if(Input.GetKey("left"))
        {
            rigid.position -= new Vector3( speed*m_Time, 0, 0);
        }
        if(Input.GetKey("right"))
        {
            rigid.position += new Vector3(speed * m_Time, 0, 0);
        }
        //前後で回転
        if (m_Jump)
        {
            if (Input.GetKey("up"))
            {
                score += 1;
                rigid.transform.Rotate(
                    m_RotatteSpeed*m_Time, 0, 0);
            }
            if (Input.GetKey("down"))
            {
                score += 1;

                rigid.transform.Rotate(
                    -(m_RotatteSpeed*m_Time), 0, 0);
            }
        }
        else
        {
            trans.rotation = m_StartRotation;
        }
        ScoreAdd();
        Jump();
	}

    void ScoreAdd()
    {
        if(ScorePuls)
        {
            SoundPlayer.PlaySE(SoundPlayer.SE.SCORE); //スコア取得時
            ScoreManager.AddScore(score);
            ScorePuls = false;
            score = 0;
        }
    }

    void Jump()
    {

        if(m_Jump)
        {
            Vector3 jump = new Vector3(0, m_High, 0);
            
            rigid.velocity = jump;
            a += gravity;
            rigid.velocity += new Vector3(0, -a, 0);
        }
        else
        {
            SplashFx.Spawn();
        }
        if(rigid.velocity.y<=-m_High)
        {
            SoundPlayer.PlaySE(SoundPlayer.SE.WATER); //着地した時
            JumpFlag = true;
            ScorePuls = true;
            a = 0.0f;
            rigid.velocity = new Vector3(0, 0, 0);
            m_Jump = false;
        }
        if (JumpFlag == true)
        {
            SoundPlayer.PlaySE(SoundPlayer.SE.JUMP); //ジャンプした時
            JumpFlag = false;
        }
    }

    void OnCollisionEnter(Collision other)
    {
        
        //タグで検索した文字を判断
        if (other.gameObject.tag == "StreamText")
        {
            m_Jump = true;
        }
    }

}
