﻿// SpeedFxObj.cs
//
// @idex Unity5.5.0f1 / MonoDevelop5.9.6
// @auth GGJFKS17C.FCEI.No-Va
// @date 2017/01/21 
//------------------------------------------------------------------------------------------------------------------------
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//----------------------------------------------------------------------------------------------------
// スピード演出用オブジェクト 
//----------------------------------------------------------------------------------------------------
public class SpeedFxObj : MonoBehaviour
{
	//--------------------------------------------------------------------------------
	// メンバ変数  
	//--------------------------------------------------------------------------------
	const float SPD       = -1.0f;	// 速度 
	const float FAR_POS   = 15.0f;	// 生まれる遠さ
	const float LIFE_TIME = 0.25f;	// 消えるまでの時間

	float timer = 0;	// ライフタイマ 

	//--------------------------------------------------------------------------------
	// パラメータ設定 
	//--------------------------------------------------------------------------------
	public void Setup (float rotate)
	{
		this.gameObject.transform.localPosition = new Vector3(
			this.gameObject.transform.localPosition.x,
			this.gameObject.transform.localPosition.y,
			this.gameObject.transform.localPosition.z + FAR_POS
		);

		this.gameObject.transform.Rotate(0, 0, rotate);
	}

	//--------------------------------------------------------------------------------
	// 更新 
	//--------------------------------------------------------------------------------
	void Update ()
	{
		this.gameObject.transform.localPosition = new Vector3(
			this.gameObject.transform.localPosition.x,
			this.gameObject.transform.localPosition.y,
			this.gameObject.transform.localPosition.z + SPD
		);

		timer += Time.deltaTime;
		if(timer > LIFE_TIME){
			GameObject.Destroy(this.gameObject);
		}
	}
}
