﻿// SplashFxObj.cs
//
// @idex Unity5.5.0f1 / MonoDevelop5.9.6
// @auth GGJFKS17C.FCEI.No-Va
// @date 2017/01/22 
//------------------------------------------------------------------------------------------------------------------------
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//----------------------------------------------------------------------------------------------------
// 文字しぶきのオブジェクト 
//----------------------------------------------------------------------------------------------------
public class SplashFxObj : MonoBehaviour
{
	//--------------------------------------------------------------------------------
	// メンバ変数 
	//--------------------------------------------------------------------------------
	[SerializeField]TextMesh textMesh = null;	//@@ テキスト 

	public Vector3 spd;					// スピード 
	const float LIFE_TIME = 0.25f;	// 消えるまでの時間 

	float timer = 0;		// ライフタイマ 

	//--------------------------------------------------------------------------------
	// パラメータ設定 
	//--------------------------------------------------------------------------------
	public void Setup (string text)
	{
		textMesh.text = text;

		spd = new Vector3(Random.Range(-0.1f, 0.1f), Random.Range(-0.1f, 0.1f), -0.3f);
		textMesh.gameObject.transform.Rotate(0, 0, Random.Range(0, 360));
	}

	//--------------------------------------------------------------------------------
	// 更新 
	//--------------------------------------------------------------------------------
	void Update ()
	{
		this.gameObject.transform.localPosition += spd;

		timer += Time.deltaTime;
		if(timer > LIFE_TIME){
			GameObject.Destroy(this.gameObject);
		}
	}
}
