﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Stream : MonoBehaviour {
    public float speed=5;//スピード
    private GameObject obj;//オブジェクト
    private TextMesh mTx;//テキストメッシュpublic float m_short=1;

	public bool isDummy{	// ダミーかどうか 
		get{
			return this.gameObject.tag=="StreamText";
		}
		private set{
			if(value){
				this.gameObject.tag = "StreamText";
			}
			else{
				this.gameObject.tag = "";
			}
		}
	}

	// Use this for initialization
	void Start () {
        obj = GameObject.Find("Main Camera");//カメラをセット

        //文字の長さによって当たり判定の大きさを変える
        mTx = GetComponent<TextMesh>();
        //SoundPlayer.PlayBGM(SoundPlayer.BGM.MAIN);
		// ダミー生成 
		int randSpeed = Random.Range(0,6);
		if(randSpeed == speed){
			isDummy = false;
		}
		else{
			isDummy = true;
			speed += randSpeed;
			mTx.text = "";
			for(int i=0; i<(10-speed); i++){
				mTx.text += SplashFx.GetRandomStr();
			}
			mTx.color = new Color(1,0,0,1);
		}
    }

    // Update is called once per frame
    void Update() {
        float time = Time.deltaTime;//フレーム経過時間
		transform.position += new Vector3(0, 0, -speed * time);//ポジションを設定
        Transform cameraTrans = obj.transform;

        if(transform.position.z<cameraTrans.position.z)
        {
            Destroy(gameObject);
        }
    }
}
