﻿// DebugSwitch.cs
//
// @idex Unity5.5.0f1 / MonoDevelop5.9.6
// @auth GGJFKS17C.FCEI.No-Va
// @date 2017/01/21 
//------------------------------------------------------------------------------------------------------------------------
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//----------------------------------------------------------------------------------------------------
// デバッグを一括ON/OFFする  
//----------------------------------------------------------------------------------------------------
public class DebugSwitch : MonoBehaviour
{
	static DebugSwitch instance;
	public static bool isDebugEnable { get{ return instance!=null; } }

	void Awake ()
	{
		// シングルトン生成 (Fast-Priority型) 
		if(instance == null){
			instance = this;
			DontDestroyOnLoad(this.gameObject);
		}
		else{
			GameObject.Destroy(this.gameObject);
		}
	}
}
